--[[------------------------------------------
Price import script for www.mtgmintcard.com
Author: Goblin Hero
Last Update: 2012-07-09
--------------------------------------------]]

--[[ Table that describe sets available for price import
	  id: numerical database set id (can be found in "Database\Sets.txt" file)
   foil:	"N" - no foils in set, "Y" - foils in set, "O" - only foils in set
chinese: "N" - no chinese cards, "Y" - chinese cards, "O" - only chinese cards
    url:	price url suffix --]]
avsets =	{
	{id = 788, foil = "Y", chinese = "Y", url = "2013+Core+set"},
	{id = 787, foil = "N", chinese = "N", url = "Planechase+2012+Edition"},
	{id = 786, foil = "Y", chinese = "Y", url = "Avacyn+Restored"},
	{id = 785, foil = "Y", chinese = "N", url = "Venser+vs.+Koth"},
	{id = 784, foil = "Y", chinese = "Y", url = "Dark+Ascension"},
	{id = 783, foil = "O", chinese = "N", url = "Graveborn"},
	{id = 782, foil = "Y", chinese = "Y", url = "Innistrad"},
	{id = 781, foil = "Y", chinese = "N", url = "Ajani+vs.+Nicol+Bolas"},
	{id = 780, foil = "O", chinese = "N", url = "From+the+Vault%3A+Legends"},
	{id = 779, foil = "Y", chinese = "Y", url = "2012+Core+Set"},
	{id = 778, foil = "N", chinese = "N", url = "Commander"},
	{id = 777, foil = "Y", chinese = "N", url = "Knights+vs.+Dragons"},
	{id = 776, foil = "Y", chinese = "Y", url = "New+Phyrexia"},
	{id = 775, foil = "Y", chinese = "Y", url = "Mirrodin+Besieged"},
	{id = 774, foil = "O", chinese = "N", url = "Fire+%26+Lightning"},
	{id = 773, foil = "Y", chinese = "Y", url = "Scars+of+Mirrodin"},
	{id = 772, foil = "Y", chinese = "N", url = "Elspeth+Vs.+Tezzeret"},
	{id = 771, foil = "O", chinese = "N", url = "From+the+Vault%3A+Relics"},
	{id = 770, foil = "Y", chinese = "Y", url = "2011+Core+Set"},
	{id = 768, foil = "Y", chinese = "Y", url = "Duels+of+the+Planeswalkers"},
	{id = 767, foil = "Y", chinese = "Y", url = "Rise+of+the+Eldrazi"},
	{id = 766, foil = "N", chinese = "N", url = "Phyrexia+VS+Coalition"},
	{id = 765, foil = "Y", chinese = "Y", url = "Worldwake"},
	{id = 764, foil = "O", chinese = "N", url = "Slivers"},
	{id = 763, foil = "Y", chinese = "N", url = "Garruk+VS+Liliana"},
	{id = 762, foil = "Y", chinese = "Y", url = "Zendikar"},
	{id = 759, foil = "Y", chinese = "Y", url = "2010+Core+Set"},
	{id = 758, foil = "Y", chinese = "Y", url = "Alara+Reborn"},
	{id = 757, foil = "Y", chinese = "N", url = "Divine+Vs+Demonic"},
	{id = 756, foil = "Y", chinese = "Y", url = "Conflux"},
	{id = 755, foil = "Y", chinese = "N", url = "Jace%2FChandra"},
	{id = 754, foil = "Y", chinese = "Y", url = "Shards+of+Alara"},
	{id = 752, foil = "Y", chinese = "Y", url = "Eventide"},
	{id = 751, foil = "Y", chinese = "Y", url = "Shadowmoor"},
	{id = 750, foil = "Y", chinese = "Y", url = "Morningtide"},
	{id = 730, foil = "Y", chinese = "Y", url = "Lorwyn"},
	{id = 720, foil = "Y", chinese = "Y", url = "10th+Edition+%28X+Edition%29"},
	{id = 710, foil = "Y", chinese = "Y", url = "Future+Sight"},
	{id = 700, foil = "Y", chinese = "Y", url = "Planar+Chaos"},
	{id = 690, foil = "Y", chinese = "N", url = "Timeshifted"},
	{id = 680, foil = "Y", chinese = "N", url = "Time+Spiral"},
	{id = 670, foil = "Y", chinese = "N", url = "Coldsnap"},
	{id = 660, foil = "Y", chinese = "N", url = "Dissension"},
	{id = 650, foil = "Y", chinese = "N", url = "Guildpact"},
	{id = 640, foil = "Y", chinese = "N", url = "Ravnica"},
	{id = 630, foil = "Y", chinese = "N", url = "9th+Edition"},
	{id = 620, foil = "Y", chinese = "N", url = "Saviors+of+Kamigawa"},
	{id = 610, foil = "Y", chinese = "N", url = "Betrayers+of+Kamigawa"},
	{id = 600, foil = "N", chinese = "N", url = "Unhinged"},
	{id = 590, foil = "Y", chinese = "N", url = "Champions+of+Kamigawa"},
	{id = 580, foil = "Y", chinese = "N", url = "Fifth+Dawn"},
	{id = 570, foil = "Y", chinese = "N", url = "Darksteel"},
	{id = 560, foil = "Y", chinese = "N", url = "Mirrodin"},
	{id = 550, foil = "Y", chinese = "N", url = "8th+Edition"},
	{id = 540, foil = "Y", chinese = "N", url = "Scourge"},
	{id = 530, foil = "Y", chinese = "N", url = "Legions"},
	{id = 520, foil = "Y", chinese = "N", url = "Onslaught"},
	{id = 510, foil = "Y", chinese = "N", url = "Judgment"},
	{id = 500, foil = "Y", chinese = "N", url = "Torment"},
	{id = 490, foil = "N", chinese = "N", url = "Deckmaster"},
	{id = 480, foil = "Y", chinese = "N", url = "Odyssey"},
	{id = 470, foil = "Y", chinese = "N", url = "Apocalypse"},
	{id = 460, foil = "Y", chinese = "N", url = "7th+Edition"},
	{id = 450, foil = "Y", chinese = "N", url = "Planeshift"},
	{id = 440, foil = "Y", chinese = "N", url = "Beatdown"},
	{id = 430, foil = "Y", chinese = "N", url = "Invasion"},
	{id = 420, foil = "Y", chinese = "N", url = "Prophecy"},
	{id = 410, foil = "Y", chinese = "N", url = "Nemesis"},
	{id = 405, foil = "Y", chinese = "N", url = "Battle+Royale"},
	{id = 400, foil = "Y", chinese = "N", url = "Mercadian+Masques"},
	{id = 370, foil = "Y", chinese = "N", url = "Urza's+Destiny"},
	{id = 360, foil = "Y", chinese = "N", url = "6th+Edition"},
	{id = 350, foil = "Y", chinese = "N", url = "Urza's+Legacy"},
	{id = 330, foil = "Y", chinese = "N", url = "Urza's+Saga"},
	{id = 320, foil = "N", chinese = "N", url = "Unglued"},
	{id = 300, foil = "N", chinese = "N", url = "Exodus"},
	{id = 290, foil = "N", chinese = "N", url = "Stronghold"},
	{id = 280, foil = "N", chinese = "N", url = "Tempest"},
	{id = 270, foil = "N", chinese = "N", url = "Weatherlight"},
	{id = 260, foil = "N", chinese = "N", url = "Portal"},
	{id = 250, foil = "N", chinese = "N", url = "5th+Edition"},
	{id = 240, foil = "N", chinese = "N", url = "Visions"},
	{id = 230, foil = "N", chinese = "N", url = "Mirage"},
	{id = 220, foil = "N", chinese = "N", url = "Alliances"},
	{id = 210, foil = "N", chinese = "N", url = "Homelands"},
	{id = 200, foil = "N", chinese = "N", url = "Chronicles"},
	{id = 190, foil = "N", chinese = "N", url = "Ice+Age"},
	{id = 180, foil = "N", chinese = "N", url = "4th+Edition"},
	{id = 170, foil = "N", chinese = "N", url = "Fallen+Empires"},
	{id = 160, foil = "N", chinese = "N", url = "The+Dark"},
	{id = 150, foil = "N", chinese = "N", url = "Legends"},
	{id = 140, foil = "N", chinese = "N", url = "3rd+Edition+(Revised)"},
	{id = 130, foil = "N", chinese = "N", url = "Antiquities"},
	{id = 120, foil = "N", chinese = "N", url = "Arabian+Nights"},
	{id = 110, foil = "N", chinese = "N", url = "Unlimited"},
	{id = 70, foil = "N", chinese = "N", url = "Vanguard"},
	{id = 50, foil = "O", chinese = "N", url = "Promo+Cards"},
	{id = 25, foil = "O", chinese = "N", url = "Promo+Cards&keywords=+-+Judge"},
	{id = 24, foil = "Y", chinese = "N", url = "Promo+Cards&keywords=nded+Art"},
	{id = 22, foil = "Y", chinese = "N", url = "Promo+Cards"},
	{id = 21, foil = "Y", chinese = "N", url = "Promo+Cards"},
	{id = 10, foil = "O", chinese = "N", url = "Promo+Cards&keywords=+-+JSS"},
	{id = 7, foil = "y", chinese = "N", url = "Promo+Cards"},
	{id = 5, foil = "N", chinese = "N", url = "Promo+Cards"},
	{id = 2, foil = "N", chinese = "N", url = "Promo+Cards&keywords=+-+Legend"},
	{id = 100, foil = "N", chinese = "N", url = "Beta"},
	{id =  90, foil = "N", chinese = "N", url = "Alpha"}
}

-- Table that define a replacement list for card names
namereplace = {
	["Akki Lavarunner"] = "Akki Lavarunner|Tok-Tok, Volcano Born",
	["Æther Tide"] = "AEther Tide",
	["Æther Flash"] = "AEther Flash",
	["Æther Storm"] = "AEther Storm",
	["Ærathi Berserker"] = "AErathi Berserker",
	["Electrolyze - Extended Art"] = "Electrolyze",
	["Rakdos Guildmage - Expanded Art"] = "Rakdos Guildmage",
	["Honor of the Pure -Prerelease Foil"] = "Honor of the Pure",
	["Memoricide - FNM Foil"] = "Memoricide",
	["Surgical Extraction - FNM Foil"] = "Surgical Extraction",
	["Armageddon - Judge Foil"] = "Armageddon",
	["Balance - Judge Foil"] = "Balance",
	["Ball Lightning - Judge Foil"] = "Ball Lightning",
	["Counterspell - Judge Foil"] = "Counterspell",
	["Gaea's Cradle - Judge Foil"] = "Gaea's Cradle",
	["Gemstone Mine - Judge Foil"] = "Gemstone Mine",
	["Grim Lavamancer - Judge Foil"] = "Grim Lavamancer",
	["Hammer of Bogardan - Judge Foil"] = "Hammer of Bogardan",
	["Lightning Bolt - Judge Foil"] = "Lightning Bolt",
	["Living Death - Judge Foil"] = "Living Death",
	["Mishra's Factory - Judge Foil"] = "Mishra's Factory",
	["Oath of Druids - Judge Foil"] = "Oath of Druids",
	["Pernicious Deed - Judge Foil"] = "Pernicious Deed",
	["Phyrexian Negator - Judge Foil"] = "Phyrexian Negator",
	["Regrowth - Judge Foil"] = "Regrowth",
	["Sol Ring - Judge Foil"] = "Sol Ring",
	["Stroke of Genius - Judge Foil"] = "Stroke of Genius",
	["Time Warp - Judge Foil"] = "Time Warp",
	["Tradewind Rider - Judge Foil"] = "Tradewind Rider",
	["Vampiric Tutor - Judge Foil"] = "Vampiric Tutor",
	["Budoka Gardener"] = "Budoka Gardener|Dokai, Weaver of Life",
	["City of Brass - JSS Foil"] = "City of Brass",
	["Crusade - JSS Foil"] = "Crusade",
	["Elvish Lyrist - JSS Foil"] = "Elvish Lyrist",
	["Giant Growth - JSS Foil"] = "Giant Growth",
	["Lord of Atlantis - JSS Foil"] = "Lord of Atlantis",
	["Serra Avatar - JSS Foil"] = "Serra Avatar",
	["Thran Quarry - JSS Foil"] = "Thran Quarry",
	["Nalathni Dragon - Insert"] = "Nalathni Dragon",
	["Scent of Cinder - Alternate Art"] = "Scent of Cinder",
	["Lightning Hounds - Insert Foil"] = "Lightning Hounds",
	["Warmonger - Insert Foil"] = "Warmonger",
	["Overtaker - Prerelease Foil"] = "Overtaker",
	["Rathi Assassin - Prerelease Foil"] = "Rathi Assassin",
	["Revenant - Prerelease"] = "Revenant",
	["Shield of Kaldra - Prerelease Foil"] = "Shield of Kaldra",
	["Silent Specter - Prerelease Foil"] = "Silent Specter",
	["Soul Collector - Prerelease Foil"] = "Soul Collector",
	["Sword of Kaldra - Prerelease Foil"] = "Sword of Kaldra",
	["Ink-Eyes, Servant of Oni - Prerelease Foil"] = "Ink-Eyes, Servant of Oni",
	["Avatar of Hope - Prerelease Foil"] = "Avatar of Hope",
	["Beast of Burden - Prerelease Foil"] = "Beast of Burden",
	["Dirtcowl Wurm - Prerelease"] = "Dirtcowl Wurm",
	["False Prophet - Prerelease Foil"] = "False Prophet",
	["Feral Throwback - Prerelease Foil"] = "Feral Throwback",
	["Helm of Kaldra - Prerelease Foil"] = "Helm of Kaldra",
	["Gleancrawler - Prerelease Foil"] = "Gleancrawler",
	["Allosaurus Rider - Prerelease Foil"] = "Allosaurus Rider",
	["Lotus Bloom - Prerelease Foil"] = "Lotus Bloom",
	["Oros, the Avenger - Prerelease Foil"] = "Oros, the Avenger",
	["Korlash, Heir to Blackblade - Prerelease Foil"] = "Korlash, Heir to Blackblade",
	["Door of Destinies -Prerelease Foil"] = "Door of Destinies",
	["Rukh Egg - Prerelease Foil"] = "Rukh Egg",
	["Ghost-Lit Raider - Release Foil"] = "Ghost-Lit Raider",
	["Marit Lage Token - Coldsnap Foil"] = "Marit Lage",
	["Force of Nature - Prerelease Foil"] = "Force of Nature",
	["Incinerate - Legend"] = "Incinerate",
	["Arena - Book"] = "Arena",
	["Giant Badger - Book"] = "Giant Badger",
	["Sewers of Estark - Book"] = "Sewers of Estark",
	["Windseeker Centaur - Book"] = "Windseeker Centaur",
	["Budoka Pupil"] = "Budoka Pupil|Ichiga, Who Topples Oaks",
	["Bushi Tenderfoot"] = "Bushi Tenderfoot|Kenzo the Hardhearted",
	["Callow Jushi"] = "Callow Jushi|Jaraku the Interloper",
	["Cunning Bandit"] = "Cunning Bandit|Azamuki, Treachery Incarnate",
	["Curse of the Nightly Haunt"] = "Curse of the Nightly Hunt",
	["DANDÂN"] = "Dandan",
	["Deja Vu"] = "Déjà Vu",
	["Elder Cather"] = "Elder Cathar",
	["Erayo, Soratami Ascendant"] = "Erayo, Soratami Ascendant|Erayo's Essence",
	["Faithful Squire"] = "Faithful Squire|Kaiso, Memory of Loyalty",
	["Fire-Ice"] = "Fire|Ice",
	["Gust Skimmer"] = "Gust-Skimmer",
	["Hired Muscle"] = "Hired Muscle|Scarmaker",
	["Homura, Human Ascendant"] = "Homura, Human Ascendant|Homura's Essence",
	["Hunger of the Wolfpack"] = "Hunger of the Howlpack",
	["Initiate of Blood"] = "Initiate of Blood|Goka the Unjust",
	["Jushi Apprentice"] = "Jushi Apprentice|Tomoya the Revealer",
	["Kitsune Mystic"] = "Kitsune Mystic|Autumn-Tail, Kitsune Sage",
	["Kuon, Ogre Ascendant"] = "Kuon, Ogre Ascendant|Kuon's Essence",
	["Nezumi Graverobber"] = "Nezumi Graverobber|Nighteyes the Desecrator",
	["Nezumi Shortfang"] = "Nezumi Shortfang|Stabwhisker the Odious",
	["Orochi Eggwatcher"] = "Orochi Eggwatcher|Shidako, Broodmistress",
	["Runeclaw Bears"] = "Runeclaw Bear",
	["Rune-Tail, Kitsune Ascendant"] = "Rune-Tail, Kitsune Ascendant|Rune-Tail's Essence",
	["Sasaya, Orochi Ascendant"] = "Sasaya, Orochi Ascendant|Sasaya's Essence",
	["Sharuum, the Hegemon"] = "Sharuum the Hegemon",
	["Student of Elements"] = "Student of Elements|Tobita, Master of Winds",
	["Urabrask, the Hidden"] = "Urabrask the Hidden"
}

-- Table that define a replacement list for foil
foiltweak = {
	{setid = 766, cardname = "Phyrexian Negator", foil = 1},
	{setid = 766, cardname = "Urza's Rage", foil = 1},
}

--[[ Function that download and parse one html file
    set: set record from avsets
setname: set name, needed only for progressbar
   foil: should we parse foil
 langid: language id --]]
function parsehtml(set, setname, foil, langid)
	-- Update progress
	curhtmlnum = curhtmlnum + 1
	local pmesg = "Parsing "
	if langid == 9 then pmesg = pmesg .. "CHN " else pmesg = pmesg .. "ENG " end
	if foil == 1 then pmesg = pmesg .. "FOIL " end
	ma.SetProgress(pmesg .. setname, 100*curhtmlnum/totalhtmlnum)
	-- Construct URL
	local url = "http://www.mtgmintcard.com/mtg"
	if langid == 9 then url = url .. "c" end
	url = url .. "_search_result.php?search_result=500&edition=" .. set.url
	if foil == 1 then url = url .. "&mode=Foils" end
	-- Download page
	ma.Log("Parsing " .. url)
	local htmldata = ma.GetUrl(url)
	if htmldata ~= nil then
		-- Pattern matching, tricky thing, read http://www.lua.org/manual/5.0/manual.html#5.3 for better understanding
		for name, price in string.gmatch(htmldata, "class=\"cardBorderBlack\".-<a[^>]+>([^<]+)<.->$([%d.,]+)") do
			-- Parse card price
			price = string.gsub(price, ",", "")
			-- Parse card name
			name = string.gsub(name, "%(Chinese Version%)", "")
			name = string.gsub(name, "^%s*(.-)%s*$", "%1")
			name = string.gsub(name, "  "," ")
			name = string.gsub(name, " / ","|")
			name = string.gsub(name, " // ","|")
			name = string.gsub(name, "/","|")
			name = string.gsub(name, "Ã†", "AE")
			name = string.gsub(name, "AE", "Æ")
			name = string.gsub(name, "Ã©", "e")
			name = string.gsub(name, "Ã¢", "a")
			name = string.gsub(name, "Ã ", "a")
			name = string.gsub(name, "Â®", "®")
			name = string.gsub(name, "[ ]*%([^']+%)$", "")
			if namereplace[name] ~= nil then name = namereplace[name] end
			-- Check for foil status patch
			local foilstat = foil
			for _, rec in ipairs(foiltweak) do
				if rec.setid == set.id and rec.cardname == name then foilstat = rec.foil end
			end
			-- Set the price
			local regprice = 0
			local foilprice = 0
			if foilstat == 1 then foilprice = price else regprice = price end
			local result = ma.SetPrice(set.id, langid, name, "", regprice, foilprice)
			-- If no matches found, try with all versions
			if result == 0 then ma.SetPrice(set.id, langid, name, "*", regprice, foilprice) end
		end
	else
		ma.Log("GetUrl failed")
	end
end

-- Main startup function
function ImportPrice(importfoil, importlangs, importsets)
	-- Calculate total number of html pages to parse (need this for progress bar)
	totalhtmlnum = 0
	for _, rec in ipairs(avsets) do
		if importsets[rec.id] ~= nil then
			local perlangnum = 0
			if importfoil ~= "O" and rec.foil ~= "O" then perlangnum = perlangnum + 1 end
			if importfoil ~= "N" and rec.foil ~= "N" then perlangnum = perlangnum + 1 end
			if importlangs[1] ~= nil and rec.chinese ~= "O" then totalhtmlnum = totalhtmlnum + perlangnum end
			if importlangs[9] ~= nil and rec.chinese ~= "N" then totalhtmlnum = totalhtmlnum + perlangnum end
		end
	end
	-- Main import cycle
	curhtmlnum = 0
	for _, rec in ipairs(avsets) do
		if importsets[rec.id] ~= nil then
			if importfoil ~= "O" and rec.foil ~= "O" and importlangs[1] ~= nil and rec.chinese ~= "O" then parsehtml(rec, importsets[rec.id], 0, 1) end
			if importfoil ~= "N" and rec.foil ~= "N" and importlangs[1] ~= nil and rec.chinese ~= "O" then parsehtml(rec, importsets[rec.id], 1, 1) end
			if importfoil ~= "O" and rec.foil ~= "O" and importlangs[9] ~= nil and rec.chinese ~= "N" then parsehtml(rec, importsets[rec.id], 0, 9) end
			if importfoil ~= "N" and rec.foil ~= "N" and importlangs[9] ~= nil and rec.chinese ~= "N" then parsehtml(rec, importsets[rec.id], 1, 9) end
		end
	end
end
